unit phylOrganiDater;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, Grids, MyNewgrid,ExtCtrls,typedef,StructureDonnees,Donnees, GR32_Image,
   Menus, Buttons, ColorStringGrid,ArbreDate,listarray2,
  Gr32,Gr32_Layers, Spin;
type
  TFormIOrganiDater = class(TForm)
    PanelHaut: TPanel;
    PanelGraphe: TScrollBox;
    PanelSupportInfo: TPanel;
    MainMenu1: TMainMenu;
    Copier1: TMenuItem;
    Fermer1: TMenuItem;
    Imprimer1: TMenuItem;
    CopierArbre: TMenuItem;
    ImprimAbre: TMenuItem;
    ImprimTableau: TMenuItem;
    CopierTableau: TMenuItem;
    PanelInfo: TPanel;
    MenuChoix: TPopupMenu;
    AfficherEpoques: TMenuItem;
    AfficherPeriodes: TMenuItem;
    AfficherEres: TMenuItem;
    AfficherCrises: TMenuItem;
    BChoix: TPanel;
    PanelAgeMax: TPanel;
    ValAgeMax: TSpinEdit;
    BOKAgeMax: TButton;
    Label2: TLabel;
    N1: TMenuItem;
    ChoixMaxiAge: TMenuItem;
    MenuDocs: TPopupMenu;
    MConseil: TMenuItem;
    PanelGrille: TPanel;
    PanelLeg: TPanel;
    PanLegCoul: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    PanelBoutons: TPanel;
    BVerifier: TButton;
    PanActiv: TPanel;
    PanBDepl: TPanel;
    TextDepla: TLabel;
    Bdepla: TSpeedButton;
    PanBDocs: TPanel;
    TextDocs: TLabel;
    BDocs: TSpeedButton;
    Panel2: TPanel;
    BDocsAutres: TButton;
    Panel1: TPanel;
    TabGrid1: TTabGrid;
    Splitter1: TSplitter;
    ComboTypes: TComboBox;
    Fermer: TButton;
    Splitter2: TSplitter;
    ComboCar: TComboBox;
    ColorBox1: TColorBox;
    procedure TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
//    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure Splitter1CanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure RAZClick(Sender: TObject);
    procedure ActiverClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BdeplaClick(Sender: TObject);
    procedure BtVerifierClick(Sender: TObject);
    procedure IllustrerCaractereClick(Sender: TObject);
    procedure TextDocsClick(Sender: TObject);
    procedure TabGrid1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FermerClick(Sender: TObject);
    procedure BDocsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure CopierArbreClick(Sender: TObject);
    procedure CopierTableauClick(Sender: TObject);
    procedure ImprimAbreClick(Sender: TObject);
    procedure ImprimTableauClick(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure AfficherEpoquesClick(Sender: TObject);
    procedure AfficherPeriodesClick(Sender: TObject);
    procedure AfficherEresClick(Sender: TObject);
    procedure AfficherCrisesClick(Sender: TObject);
    procedure BChoixClick(Sender: TObject);
    procedure BOKAgeMaxClick(Sender: TObject);
    procedure ChoixMaxiAgeClick(Sender: TObject);
    procedure BDocsAutresClick(Sender: TObject);
    procedure MConseilClick(Sender: TObject);
    procedure ComboTypesChange(Sender: TObject);
      {procedure afficherNode (node :TNodeBoite)    ;
      procedure afficherNodeG (nodeG :TNodeBoiteG)  ;  }
  private
    { Dclarations prives}                                          
    InactiveMouseUp:Boolean;
    MaxiTaxEtatDeriv:integer; // nombre maxi de taxons tant  l'tat driv pour un caractre
    CarMaxTaxED:string;
    NbTaxEtatDeriv:Array of integer; // nombre de taxons tant  l'tat driv pour le caractre i
                                     //l'indice correspond  la numrotation des caracteresD
    EtatsDerives:TStringList;
    ColCliquee,LgCliquee:integer;
    //X0Souris,Y0Souris:integer;
    //NommerBoite:Boolean;
    //GroupeANommer:string;
    NumType: integer;

    Procedure AjusteInfo(Sender:TObject);
    procedure ArbreDateKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  public  { Dclarations publiques}
     RacineSansDerive:boolean;
     DeplacementPossible:boolean;
     InitialiserCouleurs:Boolean;
     AfDExcl,AfD,AfA:TAffichCoul;
     AfOK,AfImpos,AfErr,AfMoins:TAffichCoul;
     ListeType:TStringList;
     CaracImpossibles:TStringList;
     ListeCarReserve:TStringList;
     ListeCarUtil:TStringList;
     ValeurRef:Array of integer; // nombre de taxons tant  l'tat driv pour le caractre
                                 // index comme ListeType
     //ArbreDisponible:boolean;
     NbLignesEnTete:integer;
     ArbreDate:TArbreDate;
     profils:Array of string;
     numcol:integer;
     DejaOuverte:Boolean;
     AgeMax:integer;//Maxi initial de l'chelle en millions d'annes
     ListeDocs:TStringList;
     Instructions:string;
     procedure ChargeTabGrid;
     procedure  rechercherEtatDerives( caractere :String);
     function  rechercherEtatPrimitif( caractere :String): string;
     //procedure TabGrid1ClicCaractere(col:integer);
     procedure CalculeListeRef;
     procedure ColoreMatrice;
     procedure ReclasserTableau(TableauRef:TStrListArray);
     procedure CreeArbre(ChaineStruct:string;TypeStruct:integer);
     procedure CalculeProfils;
     //Function SuiteDeZeros(n:integer):string;
     procedure AjusteLargeurCol;
     Procedure RemplitTableau;
     function Incompatible(Car1,Car2:string):Boolean;
     procedure ChargerEChelleStrati;
     procedure RefDocClick(Sender:TObject);
     procedure ChargeDoc(NomDoc:string);
     procedure InitialiseListeDocs;
     procedure AfficheInstructions;
  end;

var
  FormIOrganiDater: TFormIOrganiDater;

implementation

uses PhylChoi, PhylMain,math,fenarbre,ChxCoul,AfDocs,node,FicEssai,NmGroup,PhylParente,
     utils;

{$R *.DFM}


procedure TFormIOrganiDater.ColoreMatrice;
Var
  i,j:integer;
  AfficheDerive:TAffichCell;
  //AffichePrimitif:TAffichCell;
  AfficheRaz:TAffichCell;
  Aff:TAffichCell;
  //UnAffichage:TAffichCell;
  LeCarD:TCaractD;
  //LAncetre:TAncetreLayer;
  NomCar:string;
  //LeMenu:TMenuItem;
begin
{  if  ColorerDerive then  // Pour colorer le fond du texte correspondant  une cellule dont l'tat est volu
    begin }
  AfficheDerive.Active:=True;
  AfficheDerive.CouleurFond:=clYellow;
  AfficheDerive.CouleurTexte:=clBlack;
  AfficheDerive.styleFond:=bsSolid;
  AfficheDerive.CouleurContour:=ClBlack;
  AfficheRaz:=AfficheDerive;
  AfficheRaz.Active:=False;
  AfficheRaz.CouleurFond:=clWhite;
  {
  AffichePrimitif:=AfficheDerive;
  AffichePrimitif.CouleurFond:=ClRed;
  AffichePrimitif.CouleurTexte:=clBlue;
  AffichePrimitif.styleFond:=bsDiagCross;
  UnAffichage:=AfficheDerive;
  }
  For i:=1 to TabGrid1.ColCount-1 do
    begin
      LeCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
      if LeCarD<>Nil then
        begin
          LeCarD.Selected:=True;
          For j:=TabGrid1.FixedRows to TabGrid1.RowCount-1 do
            begin
              if (TabGrid1.Cells[i,j]<>'?') and (LeCarD.ListeEtats.IndexOf(TabGrid1.Cells[i,j])>0) then
              //TabGrid1.Cells[i,j]=rechercherEtatDerive(carac) then
                begin
                  TabGrid1.AffichCell[i,j]:=AfficheDerive;
                end
              else TabGrid1.AffichCell[i,j]:=AfficheRaz;
              {else if TabGrid1.Cells[i,j]=rechercherEtatPrimitif(carac) then
                TabGrid1.AffichCell[i,j]:=AffichePrimitif;}
            end;
        end;
    end;
  ListeCarReserve.Clear;
  for i:=0 to LaSousCollection.Caracteres.CarDs.NbCarD-1 do
    begin
      NomCar:=LaSousCollection.Caracteres.GetNomCarD(i);
      LeCarD:=LaSousCollection.LeCarD(NomCar);
      if (LeCarD<>Nil) and (ListeCarUtil.IndexOf(NomCar)=-1) then ListeCarReserve.Add(NomCar);
    end;

  Aff.Active:=False;
  Aff.CouleurTexte:=clBlack;
  Aff.styleFond:=bsSolid;
  Aff.CouleurContour:=clBlack;
  if InitialiserCouleurs then
    begin
      InitialiserCouleurs:=False;
      LaSousCollection.Caracteres.RazDActive;
      For i:=0 to TabGrid1.ColCount-1 do
        begin
          LeCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
          if LeCarD<>Nil then LeCarD.Active:=True;
        end;
      LaSousCollection.Caracteres.CarDs.CouleursDefaut;
    end;
  For i:=1 to TabGrid1.ColCount-1 do
    begin
      Aff.Active:=False;
      LeCarD:=LaSousCollection.LeCarD(TabGrid1.Cells[i,0]);
      Aff.CouleurFond:=LeCarD.Couleur;
      For j:=0 to Tabgrid1.FixedRows-1 do
        begin
          TabGrid1.AffichCell[i,j]:=Aff;
        end;
    end;
  TabGrid1.FusionFixedRow:=True;
end;

procedure TFormIOrganiDater.ReclasserTableau(TableauRef:TStrListArray);
begin
  ClasserTableauDapres(Tableauref,TabGrid1);
  InitialiserCouleurs:=True;
  ColoreMatrice;
  //AjusteLargeurCol;
end;


function TFormIOrganiDater.rechercherEtatPrimitif( caractere :String): string;
var
  LeCaractereD:TCaractD;
begin
  Result:='';
  LeCaractereD:=LaSousCollection.LeCarD(caractere);
  if (LeCaractereD<>Nil) then
    begin
      Result:=LeCaractereD.ListeEtats[0];
      if LeCaractereD.TypeCarD>0 then //si ordonn mais pb avec les .cod par dfaut
        begin
        end
    end;
end;
//** voir si il faut dfinir l'tat driv comme celui de rang 1 ou celui de dernier rang  avec le problme des ?
procedure TFormIOrganiDater.RechercherEtatDerives( caractere :String);
var
  LeCaractereD:TCaractD;
  i:integer;
  etat:string;
begin
  EtatsDerives.Clear;
  LeCaractereD:=LaSousCollection.LeCarD(caractere);
  if (LeCaractereD<>Nil) then
    begin
      For i:=1 to LeCaractereD.ListeEtats.Count-1 do
        begin
          etat:=LeCaractereD.ListeEtats[i];
          if (trim(etat)<>'?')and (trim(etat)<>'') then EtatsDerives.Add(etat);
        end;
    end;
end;

procedure TFormIOrganiDater.TabGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  col,row:integer;
  etat: string ;
  NomTaxon:string;
  NomCaractere:string;
begin
  TabGrid1.MouseToCell(X,Y,col,row);
  if (col=0) and (((Row>=TabGrid1.FixedRows) and (Button=mbRight)) or BDocs.Down) then
    begin
      NomTaxon:=TabGrid1.Cells[0,Row];
      AfficheDocs.AfficheTaxon(NomTaxon);
    end
  else if (col>0) and (Row=0) and (Button=mbRight) then
    begin
      ColCliquee:=Col;
      LgCliquee:=Row;
      NomCaractere:=TabGrid1.Cells[Col,0];
    end
  else if ((col>0) and (Row>=TabGrid1.FixedRows)) and ((Button=mbRight) or BDocs.Down) then    // clic droit
    begin
      NomTaxon:=TabGrid1.Cells[0,Row];
      NomCaractere:=TabGrid1.Cells[Col,0];
      etat:=TabGrid1.Cells[Col,Row];
      //AfficheDocs.AfficheTaxonEtCarD(NomTaxon,NomCaractere,etat);
      AfficheDocs.AfficheCarD(NomTaxon,NomCaractere,etat);
    end
  else
    begin
      if BDocs.Down then
        begin
          if (col>0) and (Row<TabGrid1.FixedRows) then
            begin
              NomCaractere:=TabGrid1.Cells[Col,Row];
              if NomCaractere<>'' then
                AfficheDocs.IllustreEtats(NomCaractere);
            end;
        end;
    end;

  splitter1.Cursor:=crVSplit;
end;

procedure TFormIOrganiDater.CalculeListeRef;
Var
  LeCarD:TCaractD;
  //NumCarD:integer;
  i,j,n,k,nbp:integer;
  premNum:integer;
  valeur:integer;
begin
  //  Calcul de  MaxiTaxEtatDeriv et des NbTaxEtatDeriv // nombre maxi de taxons tant  l'tat driv pour un caractre
  MaxiTaxEtatDeriv:=0;
  ListeType.Clear;
  SetLength(NbTaxEtatDeriv,LaSousCollection.Caracteres.CarDs.NbCarD);
  for i:=0 to LaSousCollection.Caracteres.CarDs.NbCarD-1 do
    begin
      LeCarD:=LaSousCollection.CarD[i];
      n:=TabGrid1.Rows[0].IndexOf(LeCarD.Nom);
      if n>0  then
        begin
          NbTaxEtatDeriv[i]:=0;
          ListeType.Add(LeCarD.Nom);
{          for j:=1 to TabGrid1.RowCount-1 do
            begin
              if (TabGrid1.Cells[n,j]<>'?') and (LeCarD.ListeEtats.IndexOf(TabGrid1.Cells[n,j])>0) then
              NbTaxEtatDeriv[i]:=NbTaxEtatDeriv[i]+1;
            end;
}         // compter par tats et prendre le plus fort nombre
          for k:=1 to LeCarD.ListeEtats.Count-1 do
            begin
              if LeCarD.ListeEtats[k]<>'?' then
                begin
                  nbp:=0;
                  for j:=1 to TabGrid1.RowCount-1 do
                    if TabGrid1.Cells[n,j]=LeCarD.ListeEtats[k] then inc(nbp);
                  if nbp>NbTaxEtatDeriv[i] then NbTaxEtatDeriv[i]:=nbp;
                end;
            end;
          
          if NbTaxEtatDeriv[i]>MaxiTaxEtatDeriv then
            begin
              MaxiTaxEtatDeriv:=NbTaxEtatDeriv[i];
              CarMaxTaxED:=LeCarD.Nom;
            end;
        end
      else NbTaxEtatDeriv[i]:=0;
    end;
  premNum:=0;//mise en ordre de la liste
  valeur:=MaxiTaxEtatDeriv;
  SetLength(ValeurRef,ListeType.Count);
  while (premNum<ListeType.Count)and(valeur>-1) do
    begin
      for i:=premNum to ListeType.Count-1 do
        begin
          n:=LaSousCollection.Caracteres.GetNumCarD(ListeType[i]);
          if n>-1 then
            begin
              if NbTaxEtatDeriv[n]=valeur then
                begin
                  ListeType.Move(i,premNum);
                  ValeurRef[premNum]:=valeur;
                  inc(premNum);
                end;
            end;
        end;
      Dec(Valeur);
    end;
end;
procedure TFormIOrganiDater.CalculeProfils;
Var
  i,j,numetat,numCarD :integer; //row,n,,nbp,numCarDj
  carac,etat :string; //taxon,
  LeCarD:TCaractD;
  //absent:boolean;
begin
  //nbp:=0;
  setLength(profils,TabGrid1.ColCount-1);
  For i:=0 to TabGrid1.ColCount-2 do
    begin
      //absent:=true;
      profils[i]:='';
      Carac:=TabGrid1.Cells[i+1,0];
      numCarD:=LaSousCollection.Caracteres.GetNumCarD(Carac);
      if numCarD>-1 then
        begin
          for j:=TabGrid1.FixedRows to TabGrid1.RowCount-1 do
            begin
              etat:=TabGrid1.Cells[i+1,j];
              LeCarD:=LaSousCollection.CarD[numCarD];
              numetat:=LeCarD.ListeEtats.IndexOf(etat);
              profils[i]:=profils[i]+IntToStr(numetat);
            end;
        end;
    end;
end;
Procedure TFormIOrganiDater.RemplitTableau;
Var
  i,j,p:integer;
begin
  if TableauCorrect then
    begin
      TabGrid1.RowCount:=FormChoisir.TabGrid1.RowCount;
      TabGrid1.ColCount:=FormChoisir.TabGrid1.ColCount;
    end
  else
    begin
      TabGrid1.RowCount:=LaSousCollection.TabRef.RowCount;
      TabGrid1.ColCount:=LaSousCollection.TabRef.GetMaxColCount;
    end;
{  TabGrid1.ColCount:=ListCaracteres.SelCount+1;
  p:=0;
  TabGrid1.Cells[p,0]:='';
  For i:=0 to ListCaracteres.Count-1 do
    if ListCaracteres.Selected[i] then
      begin
        inc(p);
        TabGrid1.Cells[p,0]:=ListCaracteres.Items[i];
      end;
}
  if TableauCorrect then
    begin
      For i:=1 to TabGrid1.RowCount-1 do
        TabGrid1.Cells[0,i]:=FormChoisir.TabGrid1.Cells[0,i];
      For i:=1 to TabGrid1.ColCount-1 do
        TabGrid1.Cells[i,0]:=FormChoisir.TabGrid1.Cells[i,0];
    end
  else
    begin
      For i:=1 to TabGrid1.RowCount-1 do
        TabGrid1.Cells[0,i]:=LaSousCollection.TabRef.StrItems[i,0];
      For i:=1 to TabGrid1.ColCount-1 do
        TabGrid1.Cells[i,0]:=LaSousCollection.TabRef.StrItems[0,i];
    end;

  For i:=1 to TabGrid1.RowCount-1 do
    For j:=1 to TabGrid1.ColCount-1 do
      TabGrid1.Cells[j,i]:=LaSousCollection.EtatDe(TabGrid1.Cells[0,i],TabGrid1.Cells[j,0],p);
 If TabGrid1.ColCount>1 then  TabGrid1.FixedCols:=1;
 If TabGrid1.RowCount>1 then  TabGrid1.FixedRows:=1;
end;

procedure TFormIOrganiDater.ChargeTabGrid;
var
  ListArray: TStrListArray;
  //ListAges:TStrListArray;
  i:integer;
begin
  //FormPrinc.AClasse:=nil;
  TabGrid1.SelectAllCol(false);
  NbLignesEnTete:=1;
  numcol:=1;
  ColCliquee:=0;
  LgCliquee:=0;
  LaSousCollection.Caracteres.RazSelect;
  //if FormPrinc.AClasse = nil then
  //  begin
      DeplacementPossible:=False;
      //RemplitListeCar;
      RemplitTableau;
      ListArray:=TStrListArray.createlistArray;
      if TableauCorrect then
        FormChoisir.TabGrid1.CopyToAlistArray(0,0,ListArray)
      else LaSousCollection.TabRef.CopyTo(ListArray);
      //ListAges:=LaSousCollection.CreeTabAges(ListArray);
      //FormPrinc.AClasse:= graphtri21.treeBoite;

      TabGrid1.Invalidate;
      if LaSousCollection.Caracteres.CodesEtats=nil then
        begin
          LaSousCollection.Caracteres.CreeCodeSEtats
        end;
      TabGrid1.FTabCod:=LaSousCollection.Caracteres.CodesEtats;

      CalculeProfils;
      //  Ajustement des taxons slectionns
      For i:=0 to LaSousCollection.Taxons.NbTaxons-1 do
        TTaxon(LaSousCollection.Taxons[i]).Selected:=(TabGrid1.Cols[0].IndexOf(TTaxon(LaSousCollection.Taxons[i]).Nom)>-1);
      CalculeListeRef;

      PanelGrille.Height:=Min(Round(Self.Height/1.5),TabGrid1.RowCount*(TabGrid1.DefaultRowHeight+1)+24);
      If PanelGrille.Height<(Fermer.Top+Fermer.Height+5) then PanelGrille.Height:=(Fermer.Top+Fermer.Height+5);
      ListeCarUtil.Clear;
      For i:=1 to TabGrid1.ColCount-1 do
        ListeCarUtil.Add(TabGrid1.Cells[i,0]);
      InitialiserCouleurs:=True;
      ColoreMatrice;
    //end;
end;

procedure TFormIOrganiDater.FormCreate(Sender: TObject);
Var
  NomFichier:string;
begin
   //FormPrinc.Fille(Self);
   EtatsDerives:=TStringList.Create;
   ListeType:=TStringList.Create;
   ListeCarReserve:=TStringList.Create;
   ListeCarUtil:=TStringList.Create;
   ListeDocs:=TStringList.Create;
   TabGrid1.InactiverDroit:=True;
   InitialiserCouleurs:=True;
   NbLignesEnTete:=1;
   numcol:=1;
   ColCliquee:=0;
   LgCliquee:=0;
   ArbreDate:=TArbreDate.Create(PanelGraphe);
   ArbreDate.parent:=PanelGraphe;
   ArbreDate.Align:=alNone;
   ArbreDate.Left:=0;
   ArbreDate.Top:=0;
   NomFichier:=CheminEchelleStrati+'\EchelleSimpl.txt';
   if FileExists(NomFichier) then
      ArbreDate.ChargeFichierStrati(NomFichier);

   if LaSousCollection.FModeCollege then
     begin
       Panel4.Caption:='prsent';
       Label1.Caption:='caractre prsent';  //+chr(13)+'chez l''espce'
       Instructions:='Dplacer les anctres et les espces, avec la souris, pour les placer correctement sur l''chelle du temps';
     end
   else
     begin
       Panel4.Caption:='tat';
       Label1.Caption:='tat driv'+chr(13)+'du caractre';
       Instructions:='Dplacer les anctres (noeuds) et les taxons, avec la souris, pour les placer correctement sur l''chelle du temps';
     end;

   PanelGrille.Height:=Round(Height/1.5);//Height div 2;
   InactiveMouseUp:=False;
   AfDExcl:=ConvertitAffCelAffCoul(ModDeriveExcl);
   AfD:=ConvertitAffCelAffCoul(ModDerive);
   AfA:=ConvertitAffCelAffCoul(ModAncestral);

   {AfDExcl.Active:=True;
   AfDExcl.CouleurFond:=CouleurAncDesc;
   AfDExcl.CouleurTexte:=ClBlack;
   AfDExcl.styleFond:=bsSolid;
   AfDExcl.CouleurContour:=clBlack;
   AfD:=AfDExcl;
   AfD.CouleurFond:=CouleurAncHorsGroupe;
   AfD.CouleurTexte:=clWhite;
   AfA.Active:=false;
   }
   AfOK:=AfDExcl;
   AfOK.CouleurFond:=clLime;
   AfImpos:=AfD;
   AfImpos.CouleurFond:=clRed;
   AfMoins:=AfImpos;
   AfMoins.CouleurFond:=clBlue;
   AfErr:=AfDExcl;
   AfErr.CouleurFond:=$00C0FF;

end;

 // jfr modifie le 07/03/02    fonction rajoute
procedure TFormIOrganiDater.Splitter1CanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept:=False;
  if (NewSize>30) and ((Height-NewSize-Splitter1.Height)>30) then Accept:=True;
end;

procedure TFormIOrganiDater.RAZClick(Sender: TObject);
Var
  AffRaz:TAffichCell;
begin
  //InstrucExe.Visible:=False;
  AffRaz.Active:=False;
  AffRaz.CouleurTexte:=clBlack;
  AffRaz.CouleurFond:=clWhite;
  AffRaz.CouleurContour:=ClBlack;
  ChargeTabGrid;
end;

procedure TFormIOrganiDater.ActiverClick(Sender: TObject);
begin
  if (Sender as TMenuItem).Tag=0 then
    begin
      FormPrinc.ActiverledplacementTabGrid.Checked:=true;
    end
  else
    begin
      FormPrinc.ActiverlaslectionCaractres.Checked:=True;
    end;

  DeplacementPossible:=Bdepla.Down;
  if DeplacementPossible then TabGrid1.Options:=TabGrid1.Options+[goColMoving,goRowMoving]
  else TabGrid1.Options:=TabGrid1.Options-[goColMoving,goRowMoving];
end;
procedure TFormIOrganiDater.FormDestroy(Sender: TObject);
begin
  EtatsDerives.Free;
  ListeType.Free;
  if ArbreDate<>Nil then
    begin
      ArbreDate.ToutEffacer;
      //ArbreDate.Free;
    end;
end;

procedure TFormIOrganiDater.BdeplaClick(Sender: TObject);
begin
  TabGrid1.Options:=TabGrid1.Options+[goColMoving,goRowMoving];
  TextDepla.Color:=$00C8FFC8;
  TextDocs.Color:=clBtnFace;
  BDocs.Down:=False;
  Bdepla.Down:=True;
  DeplacementPossible:=True;
end;

procedure TFormIOrganiDater.AjusteLargeurCol;
begin
  Tabgrid1.AdjustColWidths;
  TabGrid1.Refresh;
end;
function TFormIOrganiDater.Incompatible(Car1,Car2:string):Boolean;
Var
  i,numCarD1,numCarD2,NumEtat1,NumEtat2:integer;
  LeTaxon:TTaxon;
  NomTaxon,etat:string;
begin
  Result:=False;
  numCarD1:=LaSousCollection.Caracteres.GetNumCarD(Car1);
  numCarD2:=LaSousCollection.Caracteres.GetNumCarD(Car2);
  if (numCarD1>-1) and (numCarD2>-1) then
    begin
      LaSousCollection.CreeTaxonsExercice;
      //comparer les numros des tats pour tous les taxons d'exercice
      For i:=0 to Length(LaSousCollection.TaxonsExercice)-1 do
        begin
          LeTaxon:=LaSousCollection.TaxonsExercice[i];
          if LeTaxon<>Nil then
            begin
              NomTaxon:=LeTaxon.Nom;
              etat:=LaSousCollection.EtatDe(NomTaxon,Car1,NumEtat1);
              etat:=LaSousCollection.EtatDe(NomTaxon,Car2,NumEtat2);
              if (NumEtat1<>NumEtat2) then
                begin
                  Result:=True;
                  Exit;
                end;
            end;
        end;
    end;
end;

procedure TFormIOrganiDater.BtVerifierClick(Sender: TObject);
Var
  Mes:string;
  NbBP:integer;
  ListeErreurs:TStringList;
begin
  ListeErreurs:=TStringList.Create;
  Mes:=ArbreDate.Verifier(NbBP);
  if Mes='L''arbre est compatible avec les donnes' then
    MessageDlg(Mes,mtInformation,[mbOK],0)
  else
    begin
      if NbBP>1 then
        begin
          if MessageDlg('Le dbut est correct, voulez-vous terminer automatiquement ?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
            ArbreDate.ToutDisposer;
        end
      else
        begin
          ListeErreurs.CommaText:=Mes;
          Mes:=ListeErreurs[0];
          MessageDlg(Mes,mtInformation,[mbOK],0);
        end;
    end;
  ListeErreurs.Free;
end;
procedure TFormIOrganiDater.IllustrerCaractereClick(Sender: TObject);
Var
  NomCaractere:string;
begin
  NomCaractere:=TabGrid1.Cells[ColCliquee,LgCliquee];
  AfficheDocs.IllustreEtats(NomCaractere);
  ColCliquee:=0;
  LgCliquee:=0;
end;

procedure TFormIOrganiDater.TextDocsClick(Sender: TObject);
begin
  BDocs.Down:=True;
  BDocsClick(BDocs);
end;
procedure TFormIOrganiDater.ArbreDateKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key=70) and (ssCtrl in Shift) then    //CTRL-F
    begin
    end
  else if (Key=82) and (ssCtrl in Shift) then  //CTRL-R
    begin
    end
  else if (Key=84) and (ssCtrl in Shift) then  //CTRL-T
    begin
      ArbreDate.ToutDisposer;
    end;                                           
end;

procedure TFormIOrganiDater.TabGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=70) and (ssCtrl in Shift) then    //CTRL-F
    begin
    end
  else if (Key=82) and (ssCtrl in Shift) then  //CTRL-R
    begin
    end
  else if (Key=84) and (ssCtrl in Shift) then  //CTRL-T
    begin
      ArbreDate.ToutDisposer;
    end;
end;
procedure TFormIOrganiDater.CreeArbre(ChaineStruct:string;TypeStruct:integer);
Var
  i:integer;
  Age,AgeMaxi:integer;
  NomTaxon:string;
  UnTaxon:TTaxon;
  LaBranche:TBranche;
begin
  ControleACopier:=ArbreDate;
  if DejaOuverte then
    if Messagedlg('Effacer l''ancien arbre avant d''ouvrir',mtWarning,[mbYes,mbNo],0)=mrNo then
      begin
        BringToFront;
        exit;
      end;
  ArbreDate.ToutEffacer;
  DejaOuverte:=True;
  ArbreDate.Construit(Nil,ChaineStruct,TypeStruct,'<','>');
  AgeMaxi:=0;
  TabGrid1.Cells[1,TabGrid1.FixedRows-1]:='De';
  TabGrid1.Cells[2,TabGrid1.FixedRows-1]:='';
  For i:=TabGrid1.FixedRows to TabGrid1.RowCount-1 do
    begin
      NomTaxon:=TabGrid1.Cells[0,i];
      UnTaxon:=LaSousCollection.LeTaxon(NomTaxon);
      Labranche:=ArbreDate.LabrancheDuTaxon(NomTaxon);
      if (UnTaxon<>Nil) and (LaBranche<>Nil) then
        begin
          Age:=UnTaxon.AgeApp;
          if Age>0 then
            begin
              TabGrid1.Cells[1,i]:='-'+TranscritAge(Age);
              LaBranche.AgeApp:=Age;
              if Age>AgeMaxi then AgeMaxi:=Age;
              Age:=UnTaxon.AgeDisp;
              LaBranche.AgeDisp:=Age;
              if LaBranche.Curseurs<>Nil then
                begin
                  If LaBranche.AgeApp=LaBranche.AgeDisp then
                    LaBranche.Curseurs.DeuxCurseurs:=False
                  else LaBranche.Curseurs.DeuxCurseurs:=True;
                end;
              if Age>0 then
                  TabGrid1.Cells[2,i]:='-'+TranscritAge(Age)
              else TabGrid1.Cells[2,i]:='l''actuel';
            end
          else
            begin
              TabGrid1.Cells[1,i]:='actuel';
              TabGrid1.Cells[2,i]:='';
              LaBranche.AgeApp:=0;
              LaBranche.AgeDisp:=Age;
            end;
        end;
    end;
  if AgeMaxi=0 then AgeMaxi:=600000;
  ArbreDate.Align:=alTop;
  ArbreDate.MaxiAge:=AgeMaxi+(AgeMaxi div 10);
  AgeMax:=Round(ArbreDate.MaxiAge/1000);
  if AgeMax<ArbreDate.MaxiAge then inc(AgeMax);
  ValAgeMax.Value:=AgeMax;
  ValAgeMax.MaxValue:=2*AgeMax;
  TabGrid1.AdjustColWidths;
  PanelGrille.Height:=Min(Round(Self.Height/2),TabGrid1.RowCount*(TabGrid1.DefaultRowHeight+1)+24);
  If PanelGrille.Height<(Fermer.Top+Fermer.Height+5) then PanelGrille.Height:=(Fermer.Top+Fermer.Height+5);
  TabGrid1.Invalidate;
  ArbreDate.AjusterInfo:=AjusteInfo;
  ArbreDate.OnKeyDown:=ArbreDateKeyDown;

  ArbreDate.ReDessine;
  AfficheInstructions;
  BringToFront;
end;
procedure TFormIOrganiDater.FermerClick(Sender: TObject);
begin
  Close;
end;

procedure TFormIOrganiDater.BDocsClick(Sender: TObject);
begin
  TabGrid1.Options:=TabGrid1.Options-[goColMoving,goRowMoving];
  TextDepla.Color:=clBtnFace;
  Bdepla.Down:=False;
  BDocs.Down:=True;
  TextDocs.Color:=$00C8FFC8;
end;
Procedure TFormIOrganiDater.AjusteInfo(Sender:TObject);
begin
  PanelInfo.Caption:='   '+ArbreDate.TexteInfo;
end;
procedure TFormIOrganiDater.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if FormParente<>Nil then
    if FormParente.GrapheBoite<>Nil then ControleACopier:=FormParente.GrapheBoite;
  ModalResult:=mrOk;
end;

procedure TFormIOrganiDater.FormResize(Sender: TObject);
begin
  if ArbreDate<>Nil then if ArbreDate.Bitmap<>Nil then
    begin
      ArbreDate.ReDessine;
    end;
end;

procedure TFormIOrganiDater.CopierArbreClick(Sender: TObject);
begin
  ControleACopier:=ArbreDate;
  FormPrinc.ImprimerCopierClick(Sender);
end;

procedure TFormIOrganiDater.CopierTableauClick(Sender: TObject);
begin
  ControleACopier:=Tabgrid1;
  FormPrinc.ImprimerCopierClick(Sender);
end;

procedure TFormIOrganiDater.ImprimAbreClick(Sender: TObject);
begin
  ControleACopier:=ArbreDate;
  FormPrinc.ImprimerCopierClick(Sender);
end;

procedure TFormIOrganiDater.ImprimTableauClick(Sender: TObject);
begin
  ControleACopier:=Tabgrid1;
  FormPrinc.ImprimerCopierClick(Sender);
end;

procedure TFormIOrganiDater.Fermer1Click(Sender: TObject);
begin
  Close;
end;
procedure TFormIOrganiDater.ChargerEChelleStrati;
begin
end;
procedure TFormIOrganiDater.AfficherEpoquesClick(Sender: TObject);
begin
  AfficherEpoques.Checked:=Not AfficherEpoques.Checked;
  ArbreDate.AfficherCatStrati[Epoque]:=AfficherEpoques.Checked;
  ArbreDate.Redessine;
end;

procedure TFormIOrganiDater.AfficherPeriodesClick(Sender: TObject);
begin
  AfficherPeriodes.Checked:=Not AfficherPeriodes.Checked;
  ArbreDate.AfficherCatStrati[Periode]:=AfficherPeriodes.Checked;
  ArbreDate.Redessine;
end;

procedure TFormIOrganiDater.AfficherEresClick(Sender: TObject);
begin
  AfficherEres.Checked:=Not AfficherEres.Checked;
  ArbreDate.AfficherCatStrati[Ere]:=AfficherEres.Checked;
  ArbreDate.Redessine;
end;

procedure TFormIOrganiDater.AfficherCrisesClick(Sender: TObject);
begin
  AfficherCrises.Checked:=Not AfficherCrises.Checked;
  ArbreDate.AfficherCrises:=AfficherCrises.Checked;
  ArbreDate.Redessine;
end;

procedure TFormIOrganiDater.BChoixClick(Sender: TObject);
begin
  MenuChoix.Popup(BChoix.Width,PanelSupportInfo.Top+30);
end;

procedure TFormIOrganiDater.BOKAgeMaxClick(Sender: TObject);
Var
  i,AMax:integer;
begin
  //vrifier position ancetres
  AMax:=ValAgeMax.Value*1000;
  For i:=0 to Length(ArbreDate.Branches)-1 do
    begin
      if (ArbreDate.Branches[i].PosAgeApp>=AMax) or (ArbreDate.Branches[i].PosAgeDisp>=AMax) then
        begin
          if MessageDlg('Certains noueuds ou taxons vont se trouver hors chelle'+#10#13+'Poursuivre tout de mme ?',mtWarning,[mbYes,mbNo],0)=mrNo then
            begin
              ValAgeMax.Value:=Round(ArBreDate.MaxiAge/1000);
              PanelAgeMax.Visible:=False;
              exit;
            end;
          break;
        end;
    end;
  ArbreDate.MaxiAge:=ValAgeMax.Value*1000;
  ArbreDate.Redessine;
  PanelAgeMax.Visible:=False;
end;

procedure TFormIOrganiDater.ChoixMaxiAgeClick(Sender: TObject);
begin
  PanelAgeMax.Visible:=True;
end;
procedure TFormIOrganiDater.ChargeDoc(NomDoc:string);
Var
  Ext:string;
begin
  Ext:=UpperCase(ExtractFileExt(NomDoc));
  NomDoc:=CheminDatations+'\'+NomDoc;
  If Not FileExists(NomDoc) then exit;
  chargeFichierWin(Handle,NomDoc);
end;
procedure TFormIOrganiDater.RefDocClick(Sender:TObject);
Var
  n:integer;
begin
  n:=(Sender as TMenuItem).Tag;
  if n<ListeDocs.Count then
  ChargeDoc(ListeDocs[n]);
end;
procedure TFormIOrganiDater.InitialiseListeDocs;
Var
  UnMenuItem:TMenuItem;
  i:integer;
begin
  BDocsAutres.Visible:=False;
  MenuDocs.Items.Clear;
  if CheminDatations<>'' then
    begin
     RechercheTousFichiers(CheminDatations,ListeDocs);
     if ListeDocs.Count>0 then
       begin
         BDocsAutres.Visible:=True;
         //crer les Rpertoires;
         For i:=0 to ListeDocs.Count-1 do
           begin
             UnMenuItem:=TMenuItem.Create(MenuDocs);
             UnMenuItem.Caption:=ListeDocs[i];
             UnMenuItem.Tag:=i;
             UnMenuItem.OnClick:=RefDocClick;
             MenuDocs.Items.Add(UnMenuItem);
           end;
       end;
    end;
end;

procedure TFormIOrganiDater.BDocsAutresClick(Sender: TObject);
begin
  MenuDocs.Popup(96,496);
end;
procedure TFormIOrganiDater.AfficheInstructions;
begin
  PanelInfo.Caption:=Instructions;
end;

procedure TFormIOrganiDater.MConseilClick(Sender: TObject);
begin
  AfficheInstructions;
end;

procedure TFormIOrganiDater.ComboTypesChange(Sender: TObject);
// change la combo des caracteres en fn du type
var
   N,i: integer;
begin
 RAZControleACopier;   // Ajout JFM
 with TComboBox(Sender) do
   begin
     if (ItemIndex > Items.Count-1) or (ItemIndex < 0) then exit;
     SelStart:=0;
     NumType:=ItemIndex;
   end;
  ComboCar.Clear;
  if (ComboTypes.Text='Diverses') then
    begin
      N:=FormObs.TaxonSelect.DocsDivers.Count;
      if N=0 then
        begin
          ComboTypes.Items.Delete(ComboTypes.ItemIndex);
          ComboTypes.ItemIndex:=0;
        end
      else if N=1 then
        begin
          ComboCar.Visible:=False;
          //  remplacer par l'affichage adequat
          //FormObs.ChargeDoc(FormObs.TaxonSelect.DocsDivers[0]);
        end
      else
        begin
          ComboCar.Visible:=True;
          ComboCar.Text:='Donnes disponibles';
          ComboCar.Hint:='Donnes disponibles';
          ComboCar.SelStart:=0;
          ComboCar.Items.AddStrings(FormObs.TaxonSelect.DocsDivers);
        end;
    end
  else
    begin
      N:= LaSousCollection.Caracteres.GetNbCar(NumType);
      if N=1 then               // si un seul caractre
        begin
          ComboCar.Visible:=False; // on n'affiche pas la combo des caractres
          AfficheCar(LaSousCollection.Caracteres.GetNumCar(NumType,0)); // on affiche directement l'image du caractre
        end
      else                      // sinon on affiche la combo des caractres
        begin
          ComboCar.visible:=True;
          ComboCar.Text:='Donnes disponibles';
          ComboCar.Hint:='Donnes disponibles';
          ComboCar.SelStart:=0;
          for i:=0 to N - 1 do
            ComboCar.Items.Add(LaSousCollection.Caracteres.GetNom(LaSousCollection.Caracteres.GetNumCar(NumType,i)));
        end;
    end;
end;

end.
